// ===----------------------------------------------------------------------===//
// Copyright © 2024 Apple Inc. and the Pkl project authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//	https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ===----------------------------------------------------------------------===//
class Bike {
  isFixie: Boolean
}

abstract class Being {
  isAlive: Boolean
}

/// A Person!
open class Person extends Being {
  bike: Bike

  /// The person's first name
  firstName: UInt16?

  /// The person's last name
  lastName: Mapping<String, UInt32?>
}

typealias BugKind = "butterfly" | "beetle\"" | "beetle one" | "beetle_one"

class Bug {
  /// The owner of this bug.
  owner: Person?

  secondOwner: Person

  /// The age of this bug
  age: Int?

  /// How long the bug holds its breath for
  holdsBreathFor: Duration

  size: DataSize

  kind: BugKind
}

class Cyclic {
  a: String

  b: Int

  myself: Cyclic
}

